Page MenuHomePhabricator

Proposal: Improve the interface of Special:ViewData in the Cargo extension
Closed, ResolvedPublic

Description

Profile Information

Name: Ankita Mandal
IRC nickname: anki221
Web Profile:
Resume: https://www.linkedin.com/in/ankita-mandal-71493640/
Location: Germany
Typical working hours: 05 PM to 01AM (UTC +1)

Synopsis

The Cargo extension (https://www.mediawiki.org/wiki/Extension:Cargo) defines a page, Special:ViewData, that serves two purposes: (1) to display additional query results when a user clicks on "More results" from within a main set of query results; and (2) to provide a user interface - if a user goes directly there - to run any Cargo query. For this 2nd use, the interface could be improved quite a bit: right now the UI is just some text inputs, with no autocompletion, no validation, no additional, format-based inputs, and in general no help to the user. This project aims to provide a much more user-friendly interface, using autocompletion, dropdowns, and/or other form elements, so that users didn't have to, for example, guess what tables and fields exist on the wiki.

Mentors: @Yaron_Koren, @Nikhil-nk

PeriodTask
May 6 to May 27Community bonding period. Comparison study for ViewData page with the UI from phpMyAdmin and Semantic MediaWiki. Create Mockups in Axure.
May 28 to June 12Improve designs. Add Autocompletion and Dropdown features for input fields.
June 13 to June 19Add validation and tooltips for the fields in ViewData Special Page. Add a static Help Section with brief examples on how to use the new ViewData UI.
June 20 to June 24Announce feature in mailing lists or through other channels to the community. Create a usability study to gather feedback from MediaWiki community (needs more investigation).
June 24 to June 28Phase I evaluation
June 30 to July 7Improve features based on usability study results.
July 8 to July 14Testing the new UI and fix bugs.
July 15 to July 22Reiterate over the design. Add more features if necessary.
July 22 to July 26Phase II evaluation
July 27 to August 16Work on the final touches. Testing and documentation of the whole project. Improvements based on suggestions from mentors and Usability study.
August 16 to August 25Bug fixes, Writing documentation and Updating appropriate guides. Code cleanup for submission.
August 26 to September 2Mentors submit final student evaluations
September 3Final results of Google Summer of Code 2019 announced

Deliverables

  • Comparison study with Similar pages like SemanticWiki and phpMyAdmin
  • Mockups for the new ViewData UI
  • Code for new ViewData UI. Integration with existing Cargo code bundle.
  • Testing of the new UI to guarantee seamless functionality.
  • Conduct Usability study across the MediaWiki community and improve the UI further.
  • Write documentation and update guides.

Participation

  • Work on a separate branch on git and uploading code to the forked repo almost on a daily basis. Creating pull requests as and when a complete feature is done.
  • Online on IRC in my working hours (05 PM to 01AM (UTC +1))
  • Communication on tasks will be through commenting on subtasks to the project created on Phabricator.
  • Weekly reports will be published in my meta wiki user page
  • Publishing on my blog the summary of a task at the end of a task period as above in the timeline( https://wordpress.com/view/ankitamandal.wordpress.com)

About me

I am a second-year master’s degree student pursuing Masters in Computer Engineering (Specialization: Intelligent Networked Systems). I have already completed most of the credits in my curriculum (with a grade of 1.6 in German scale), leaving enough time and scope for participating in GSOC 2019. I shall be able to work approximately 40 hours per week and can put in more hours if necessary.

I am a firm believer in open educational resources and the work the Wikimedia Foundation is doing. In a country like India, where I come from, there is still an illiteracy rate of 20.69%. It may not be a huge number, but considering the overall population of the country, it is still quite a lot. I believe that by making MediaWiki slightly better, even if it’s just an improvement to the Cargo extension interface, we are doing something for the underprivileged sections of the society.

Past Experience

At present I am pursuing M.Sc. Computer Engineering (Intelligent Networked Systems) at University of Duisburg Essen where I have been exposed directly to research work. I have also been working at the Learning Technologies for the Centre for Information and Media Services at the University where I work as a full stack developer for e-learning applications and I have also contributed to Wikimedia Foundation while working.
Here are some of the work I have done:
A portal for vocabulary mastery intended for German high school students:
https://www.wortschatzwissen.de/demo/
Interactive Slides Ebook Project:
https://iseb.uni-due.de/
A MediaWiki extension that allows admins to change the passwords of users at a single go:
https://www.mediawiki.org/wiki/Extension:ChangeUserPasswords
Technology Stack: PHP, JavaScript, AJAX, MySQL
I have a Bachelor of Technology degree from West Bengal University of Technology (Specialization: Information Technology)
I have also previously worked for 2.5 years as a Software Test Engineer at Accenture India and Mercedes Benz India.
Technologies: Java and Selenium
Microtasks completed

Event Timeline

Smanmand created this task.Mar 14 2019, 7:55 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 14 2019, 7:55 PM
Smanmand updated the task description. (Show Details)Mar 15 2019, 8:27 AM
Smanmand updated the task description. (Show Details)Mar 15 2019, 10:49 AM
Smanmand updated the task description. (Show Details)Mar 15 2019, 10:52 AM
Smanmand updated the task description. (Show Details)Mar 29 2019, 2:46 PM
Smanmand updated the task description. (Show Details)Mar 29 2019, 2:54 PM
Smanmand updated the task description. (Show Details)Apr 8 2019, 1:41 PM

If you would like us to consider your proposal for review, please move it to the submitted column on Google-Summer-of-Code (2019) board.

Prosper added a subscriber: Prosper.EditedMay 6 2019, 6:58 PM

Reading your proposal again. And i really must say, you are the right person for this project's success. I really wish you the best as you begin work soon.

Reading your proposal again. And i really must say, you are the right person for this project's success. I really wish you the best as you begin work soon.

@Prosper : Thank you so much for your kind words! I wish you the best too :)

@Yaron_Koren : Please review my Proposal. Looking forward to your suggestions! :)

Smanmand updated the task description. (Show Details)May 7 2019, 3:22 PM
Smanmand updated the task description. (Show Details)May 27 2019, 4:25 PM

Congratulations on completing the project! If there isn't anything remaining in your proposal to address, feel free to close this task. Before you do so, make sure your project is listed here https://www.mediawiki.org/wiki/Google_Summer_of_Code/Past_projects#2019 and has the following information: Student name, Mentors, Relevant links and Outcomes (in not more than two lines).

Yaron_Koren closed this task as Resolved.Sep 11 2019, 11:11 PM